#include <math.h>
#include <stdlib.h>
#include <GL/glut.h>
#include "quat.h"

/* tO萔` */
#define FALSE 0
#define TRUE  1

/* EBhETCY */
#define WINDOW_SIZE 512

/* ̉p */
#define FOVY 20.0

/* gbN{[̑ΓIȑ傫 */
#define R 0.8

/* p萔i2̋̕tj */
#define ROOT_2_INV 0.70710678118654752440

/* GLUTj[ʗpԍ */
#define APP_QUIT 1

/* 2}N */
#define SQR(x) ((x) * (x))

/* J[ */
static const GLfloat white[] = { 1.0, 1.0, 1.0, 1.0 };
static const GLfloat blue[]  = { 0.0, 0.0, 1.0, 1.0 };
static const GLfloat black[] = { 0.0, 0.0, 0.0, 1.0 };

/* }EX[Vpϐ */
static int scaling = FALSE;  /* XP[O̕ύX */
static int begin_x, begin_y;  /* }EX̃hbOJnʒu */
static quat curr, last;  /* ]̃NH[^jI */
static GLfloat scale_factor = 1.0;  /* XP[Ol */

/* EBhETCYpϐ */
static int width = WINDOW_SIZE, height = WINDOW_SIZE;

/* aR̋ւ̓e */
static GLfloat project_to_sphere(GLfloat x, GLfloat y)
{
	GLfloat z;
	GLfloat d_sqr, d;
	
	d_sqr = SQR(x) + SQR(y);
	d = sqrt(d_sqr);  /* d(x,y)̌_̋ */
	if (d < R) {  /* (x,y)aR̉~ł */
		z = sqrt(2.0 * SQR(R) - d_sqr);
		  /* aR̉~ɊOڂ鐳`ڂ鋅ɓe */
	}
	else {  /* (x,y)aR̉~łȂ */
		z = SQR(R) / d;  /* ȉ~̂ɓe */
	}
	return z;
}

/* gbN{[̃V~[V */
static void simulate_trackball(quat *q, GLfloat p1x,
  GLfloat p1y, GLfloat p2x, GLfloat p2y)
{
	if (p1x == p2x && p1y == p2y) { 
		/* }EẌړʂ[Ȃ */
		quat_identity(q);
		  /* ACfeBeBNH[^jIԂ */
	}
	else {
		/* }EẌړʂ[łȂȂ */
		quat p1, p2, a, d;
		float p1z, p2z;
		float s, t;
		
		/* xNgp1FgbN{[ړJnʒu */
		p1z = project_to_sphere(p1x, p1y);
		quat_assign(&p1, 0.0, p1x, p1y, p1z);
		
		/* xNgp2: gbN{[ړIʒu */
		p2z = project_to_sphere(p2x, p2y);
		quat_assign(&p2, 0.0, p2x, p2y, p2z);
		
		/* gbN{[̉]߂ */
		quat_mul(&a, &p1, &p2);
		  /* xNgp2ƃxNgp1̊OςxNgaƂ */
		
		/* xNgaPʃxNgɂ */
		a.w = 0.0;
		s = quat_norm(&a);
		quat_div_real(&a, &a, s);
		
		/* gbN{[̉]ʂ߂ */
		quat_sub(&d, &p1, &p2);
		  /* xNgp1ƃxNgp2̍xNgdƂ */
		
		/* xNgd̃m */
		t = quat_norm(&d) / (2.0 * R * ROOT_2_INV);
		/* m1傫ȂĂ܂1ɂ */
		if (t > 1.0) t = 1.0;
		
		/*
		 * ]̃NH[^jI̐ݒ
		 *
		 * {͉]̃NH[^jI
		 *
		 *   theta = 2.0 * asin(t);
		 *   q->w = cos(phi / 2.0);
		 *   q->x = a.x * sin(theta / 2.0);
		 *   q->y = a.y * sin(theta / 2.0);
		 *   q->z = a.z * sin(theta / 2.0);
		 *
		 * ƌvZƂ낾CtgقvZ
		 *
		 */
		quat_assign(q, cos(asin(t)), a.x * t, a.y * t, a.z * t);
	}
}

/* NH[^jI]s */
static void create_rotation_matrix(GLfloat m[4][4],
	const quat *q)
{
	m[0][0] = 1.0 - 2.0 * (q->y * q->y + q->z * q->z);
	m[0][1] =       2.0 * (q->x * q->y - q->z * q->w);
	m[0][2] =       2.0 * (q->z * q->x + q->w * q->y);
	m[0][3] = 0.0;
	m[1][0] =       2.0 * (q->x * q->y + q->z * q->w);
	m[1][1] = 1.0 - 2.0 * (q->z * q->z + q->x * q->x);
	m[1][2] =       2.0 * (q->y * q->z - q->w * q->x);
	m[1][3] = 0.0;
	m[2][0] =       2.0 * (q->z * q->x - q->w * q->y);
	m[2][1] =       2.0 * (q->y * q->z + q->x * q->w);
	m[2][2] = 1.0 - 2.0 * (q->y * q->y + q->x * q->x);
	m[2][3] = 0.0;
	m[3][0] = 0.0;
	m[3][1] = 0.0;
	m[3][2] = 0.0;
	m[3][3] = 1.0;
}

/* t[` */
#define L 0.5
static void draw_frame(void)
{
	/* ̂̒_ʒuƕӂ̃f[^ */
	static GLfloat vdata[8][3] = {
		{ -L, -L, -L }, { L, -L, -L }, { L, L, -L }, { -L, L, -L },
		{ -L, -L, L }, { L, -L, L }, { L, L, L }, { -L, L, L } };
	static GLint tindices[6][4] = {
		{ 0, 1, 2, 3 }, { 0, 1, 5, 4 }, { 3, 0, 4, 7 },
		{ 1, 2, 6, 5 }, { 2, 3, 7, 6 },{ 5, 4, 7, 6 } };
	int i;
	
	/* 3ʂ` */
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, blue);
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, black);
	for (i = 0; i < 3; ++i) {
		glBegin(GL_QUADS);
			glNormal3fv(&vdata[tindices[i][0]][0]);
			glVertex3fv(&vdata[tindices[i][0]][0]);
			glNormal3fv(&vdata[tindices[i][1]][0]);
			glVertex3fv(&vdata[tindices[i][1]][0]);
			glNormal3fv(&vdata[tindices[i][2]][0]);
			glVertex3fv(&vdata[tindices[i][2]][0]);
			glNormal3fv(&vdata[tindices[i][3]][0]);
			glVertex3fv(&vdata[tindices[i][3]][0]);
		glEnd();
	}
}

/* ̂` */
#define X (0.525731112119133606 / 2.0)
#define Z (0.850650808352039932 / 2.0)
static void draw_object(void)
{
	/*** ɂ͍DȃR[hǂ ***/
	
	/*
	 * ȉ̃Tv͐20ʑ̂`R[h
	 * 
	 * OpenGL Programming Guide, The Official Guide to
	 * Learning OpenGL, Release 1 (OpenGL ARB) p
	 * 
	 */
	static GLfloat vdata[12][3] = {
		{ -X, 0.0, Z }, { X, 0.0, Z }, { -X, 0.0, -Z },
		{ X, 0.0, -Z }, { 0.0, Z, X }, { 0.0, Z, -X },
		{ 0.0, -Z, X }, { 0.0, -Z, -X }, { Z, X, 0.0 },
		{ -Z, X, 0.0 }, { Z, -X, 0.0 }, { -Z, -X, 0.0 } };
	static GLint tindices[20][3] = {
		{ 0, 4, 1 }, { 0, 9, 4 }, { 9, 5, 4 }, { 4, 5, 8 },
		{ 4, 8, 1 }, { 8, 10, 1 }, { 8, 3, 10 }, { 5, 3, 8 },
		{ 5, 2, 3 }, { 2, 7, 3 }, { 7, 10, 3 }, { 7, 6, 10 },
		{ 7, 11, 6 }, { 11, 0, 6 }, { 0, 1, 6 }, { 6, 1, 10 }, 
		{ 9, 0, 11 }, { 9, 11, 2 }, { 9, 2, 5 }, { 7, 2, 11 } };
	int i;
	
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE,
			white);
	for (i = 0; i < 20; ++i) {
		glBegin(GL_TRIANGLES);
			glNormal3fv(&vdata[tindices[i][0]][0]);
			glVertex3fv(&vdata[tindices[i][0]][0]);
			glNormal3fv(&vdata[tindices[i][1]][0]);
			glVertex3fv(&vdata[tindices[i][1]][0]);
			glNormal3fv(&vdata[tindices[i][2]][0]);
			glVertex3fv(&vdata[tindices[i][2]][0]);
		glEnd();
	}
}

/* GLUT`R[obN֐ */
static void draw(void)
{
	static int first_call = TRUE;
		/* ̊֐͂߂ČĂ΂ꂽ */
	static GLint display_list = 0;
		/* fBXvCXgێ */
	
	if (first_call) {  /* ̊֐ŏɌĂ΂ꂽƂ */
		first_call = FALSE;
		display_list = glGenLists(1);
			/* fBXvCXg */
		glNewList(display_list, GL_COMPILE_AND_EXECUTE);
			draw_frame();   /* t[` */
			draw_object();  /* ̂`悷 */
		glEndList();
	}
	else {  /* ̊֐2ڈȍ~ɌĂ΂ꂽƂ */
		glCallList(display_list);
			/* fBXvCXgR[ */
	}
}

/* GLUTfBXvCR[obN֐ */
static void display_func(void)
{
	static GLfloat v[4][4] = {
		{ 1.0, 0.0, 0.0, 0.0 },
		{ 0.0, 1.0, 0.0, 0.0 },
		{ 0.0, 0.0, 1.0, 0.0 },
		{ 0.0, 0.0, -4.0, 1.0 } };
	/*
	 * Mac̏ꍇ
	 *
	 * static GLfloat v[4][4] = {
	 *	{ 1.0, 0.0, 0.0, 0.0 },
	 *	{ 0.0, 1.0, 0.0, 0.0 },
	 *	{ 0.0, 0.0, -1.0, 0.0 },
	 *	{ 0.0, 0.0, 0.0, 1.0 } };
	 *
	 */
	 
	GLfloat m[4][4];  /* W̉]s */
	int i, j;
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		/* ʃNA */
	glLoadIdentity();  /* PʍsZbg */
	glMultMatrixf(&v[0][0]);  /* _ʒuZbg */
	/*
	 * Windows/Linux/FreeBSDȂglMultMatrixf̂
	 *
	 *   gluLookAt(0.0, 0.0, 4.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
	 *
	 * ƂĂ悢
	 *
	 */
	glPushMatrix();
		create_rotation_matrix(m, &curr);
			/* NH[^jI]s𐶐 */
		glScalef(scale_factor, scale_factor, scale_factor);
			/* XP[O */
		glMultMatrixf(&m[0][0]);  /* ]sZbg */
		draw();  /* `悷 */
	glPopMatrix();
	glutSwapBuffers();  /* `obt@̓ւ */
}

/* GLUTVFCvR[obN֐ */
static void reshape_func(int w, int h)
{
	glViewport(0, 0, (GLsizei)w, (GLsizei)h);
		/* EBhETCYw */
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
		/* vWFNVsɒPʍsZbg */
	gluPerspective(FOVY, (GLfloat)w/(GLfloat)h, 1.0, -100.0);
	  /* p[XyNeBuϊsZbg */
	glMatrixMode(GL_MODELVIEW);
	width = w;
	height = h;
}

/* Applicationj[֐ */
static void app_menu_func(int menu)
{
	switch (menu) {
	case APP_QUIT:
		exit(0);  /* APP_QUITj[ŃvOI */
		break;
	default:
		break;
	}
}

/* GLUTj[R[obN֐ */
static void menu_func(int dummy0)
{
	/* Ȃ */
	return;
}

/* GLUTL[{[hR[obN֐ */
static void keyboard_func(unsigned char key,
	int dummy1, int dummy2)
{
	switch (key) {
		case 'q':
		case 'Q':
		app_menu_func(APP_QUIT);
		  /* QL[ꂽAPP_QUITj[I񂾂̂Ɠ */
		break;
	default:
		break;
	}
}

/* GLUT}EXR[obN֐ */
static void mouse(int button, int state, int x, int y)
{
	if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {
		/* {^hbOJn */
		begin_x = x;
		begin_y = y;
		if (glutGetModifiers() & GLUT_ACTIVE_SHIFT) { 
			/* SHIFTL[ */
			scaling = TRUE;  /* XP[OύX */
		}
		else {  /* SHIFTL[Ȃ */
			scaling = FALSE;  /* _ύX */
		}
	}
}

/* GLUT}EX[VR[obN֐ */
static void motion(int x, int y)
{
	static int count = 0;  /* ̊֐Ă΂ꂽ */
	
	if (scaling) {  /* XP[OύXȂ */
		scale_factor = scale_factor
			* (1.0 + (((float) (begin_y - y)) / height));
		begin_x = x;
		begin_y = y;
		glutPostRedisplay();  /* ĕ` */
		return;
	}
	else {
		quat t;
		
		simulate_trackball(&last, (2.0 * begin_x - width) / width,
			(height - 2.0 * begin_y) / height,
			(2.0 * x - width) / width,
			(height - 2.0 * y) / height);
			/* 
			 * EBhES0CEBhE2ɒ
			 * }EXʒusimulate_trackballɂ킽
			 * 
			 */
		begin_x = x;
		begin_y = y;
		
		/* lastcurr̃NH[^jIςcurrɑ */
		quat_mul(&t, &last, &curr);
		curr = t;
		
		if (++count % 97) {  /* ̊֐971̊... */
			GLfloat n;
			
			/* NH[^jIcurr𐳋K */
			n = quat_norm(&curr);
			quat_div_real(&curr, &curr, n);
		}
		glutPostRedisplay();  /* ĕ` */
	}
}

/* GLUTj[̏ */
static void init_glut_menu(void)
{
	int app_menu;
	
	/* Applicationj[o^ */
	app_menu = glutCreateMenu(app_menu_func);
	glutAddMenuEntry("Quit (Q)", APP_QUIT);
	
	/* j[o^ */
	glutCreateMenu(menu_func);
	glutAddSubMenu("Application", app_menu);
	
	/* j[}EXE{^ɃA^b` */
	glutAttachMenu(GLUT_RIGHT_BUTTON);
}

/* GLUT̏ */
static void init_glut(int *argc, char **argv)
{
	glutInit(argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
		/* RGBAC_uobt@CfvXobt@w */
	glutInitWindowSize(WINDOW_SIZE, WINDOW_SIZE);
		/* EBhETCYw */
	glutInitWindowPosition(100, 100);  /* EBhEʒuw */
	glutCreateWindow(argv[0]);  /* EBhE𐶐 */
	glutKeyboardFunc(keyboard_func);
		/* L[{[hR[obN֐w */
	glutDisplayFunc(display_func);
		/* fBXvCR[obN֐w */
	glutReshapeFunc(reshape_func);
		/* VFCvR[obN֐w */
	glutMouseFunc(mouse);  /* }EXR[obN֐w */
	glutMotionFunc(motion);
		/* }EXړR[obN֐w */
	glutSetCursor(GLUT_CURSOR_RIGHT_ARROW);
		/* }EXJ[\w */
	init_glut_menu();  /* j[ */
}

/* OpenGL̏ */
static void init_gl(void)
{
	static GLfloat light1[] = { 0.0, 0.0, 10.0, 1.0 };
	/*
	 * Mac̏ꍇ
	 *
	 * static GLfloat light1[] = { 0.0, 0.0, -10.0, 1.0 };
	 *
	 */
	
	glClearColor(0.0, 0.0, 0.0, 1.0);  /* wiF̐ݒ */
	glEnable(GL_DEPTH_TEST);  /* fvXeXgL */
	glEnable(GL_NORMALIZE);
		/* @xNg̎KL */
	glEnable(GL_LIGHTING);  /* CeBOL */
	/* ArGg */
	glLightfv(GL_LIGHT0, GL_DIFFUSE, black);
		/* ftHg̃fBt[YItɂĂ */
	glEnable(GL_LIGHT0);
	/* FfBt[Y */
	glLightfv(GL_LIGHT1, GL_DIFFUSE, white);
	glLightfv(GL_LIGHT1, GL_POSITION, light1);
	glEnable(GL_LIGHT1);
	simulate_trackball(&curr, 0.0, 0.0, 0.0, 0.0);
		/* currNH[^jI */
}

/* main֐ */
int main(int argc, char **argv) {
	init_glut(&argc, argv);
	init_gl();
	glutMainLoop();
	return 0;
}
